unit Misc;

interface

uses
  SysUtils, Windows, Classes, Forms, IniFiles, Dialogs, Math;

type
  TGenerateUIDParam = (gpDecimal, gpHex, gp64, gp32);

function VarOpenArrayToVarArray(const Value: array of const) :Variant;
function VarEqual(const A :Variant; const B :Variant) :Boolean;

implementation

uses
  Variants;

function VarOpenArrayToVarArray(const Value: array of const) :Variant;
var
  VA :array of Variant;
  I: Integer;

 function VarRec2Variant(VR :TVarRec) :Variant;
 begin
   with VR do
     case VType of
       vtInteger:    Result := VInteger;
       vtBoolean:    Result := VBoolean;
       vtChar:       Result := VChar;
       vtExtended:   Result := VExtended^;
       vtString:     Result := String(VString^);
       vtPointer:    Result := Cardinal(VPointer);
       vtPChar:      Result := VPChar^;
       vtObject:     Result := Cardinal(VObject);
       vtClass:      Result := Cardinal(VClass);
       vtWideChar:   Result := VWideChar;
       vtPWideChar:  Result := VWideChar;
       vtAnsiString: Result := AnsiString(VAnsiString);
       vtCurrency:   Result := VCurrency^;
       vtVariant:    Result := VVariant^;
       vtInterface:  Result := Cardinal(VInterface);
       vtWideString: Result := String(VWideString);
       vtInt64:      Result := VInt64^;
     end;
 end;
begin
  if Length(Value) > 0 then begin
    SetLength(VA, Length(Value));
    for I := Low(Value) to High(Value) do
      VA[I] := VarRec2Variant(Value[I]);
  end
  else SetLength(VA, 1);
  Result := VarArrayOf(VA);
end;

function VarEqual(const A :Variant; const B :Variant) :Boolean;
var
  I :Integer;
begin
  Result := False;
  if VarType(A) <> VarType(B) then Exit;
  if VarIsArray(A) then begin
    if VarArrayHighBound(A, 1) <> VarArrayHighBound(B, 1) then Exit
    else for I := VarArrayLowBound(A, 1) to VarArrayHighBound(A, 1) do
      if not VarEqual(A[I], B[I]) then Exit;
  end
  else if A <> B then Exit;
  Result := True;
end;

end.
