unit UnitFormDocument;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UnitBaseMDIChildForm, Menus, DB, DBTables, Grids, DBGrids,
  ExtCtrls, StdCtrls, ActnList;

type
  TFormDocument = class(TBaseMDIChildForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query2: TQuery;
    DBGrid2: TDBGrid;
    Query2event_id: TFloatField;
    Query2event_type_id: TIntegerField;
    Query2customer_id: TIntegerField;
    Query2event_serial: TIntegerField;
    Query2event_date: TDateField;
    Query2del: TBooleanField;
    Query2sum_r: TFloatField;
    Query2sum_0: TFloatField;
    Query2sum_1: TFloatField;
    Query2description: TStringField;
    Query1event_ware_id: TIntegerField;
    Query1event_id: TFloatField;
    Query1ware_attr_id: TIntegerField;
    Query1ware_id: TIntegerField;
    Query1price_w: TFloatField;
    Query1price_r: TFloatField;
    Query1Quantity: TFloatField;
    Query1tax_nds: TFloatField;
    Query1percent_w: TFloatField;
    Query1percent_r: TFloatField;
    Query1ware_code: TFloatField;
    Query1ware_full_name: TStringField;
    Query2Customer: TStringField;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Label1: TLabel;
    Label2: TLabel;
    ActionList1: TActionList;
    FindCustomer1: TAction;
    FindCustomer11: TMenuItem;
    Button1: TButton;
    procedure CommandClick(Sender: TObject);
  private
  protected
    FCapt :String;
    procedure UpdateCaption;
  public
    procedure DocInit; override;
  end;

//var
//  FormDocument: TFormDocument;

implementation

uses
  Doc, RegisterFormConsts;

{$R *.dfm}

{ TFormDocument }

procedure TFormDocument.CommandClick(Sender: TObject);
begin
  DocManager.ShowDoc(iFormSectionThree, [1, Query2customer_id.AsInteger, Query2event_id.AsFloat])
end;

procedure TFormDocument.DocInit;
begin
  inherited;
  if not ParamsIs([]) then
    if FParams[0] = 1 then begin
      FCapt := Caption;
      Query2.ParamByName('event_id').AsFloat := FParams[1]; //   
      //        
      Query2Customer.LookupDataSet := TDataSet(Cardinal(FParams[2]));
      Query2.Open;
      //   "",   " "
      Query2Customer.Visible := Query2event_type_id.AsInteger <> 6;
      Query1.Open;
      UpdateCaption;
      //        
      Query1.Locate(Query1ware_code.FieldName, FParams[3], []);
    end;
end;

procedure TFormDocument.UpdateCaption;
var
  S :String;
begin
  S := FCapt;
  with Query2Customer do if AsString <> '' then S := S + ' - ' + AsString;
  with Query2event_serial do if AsString <> '' then S := S + ' - ' + AsString;
  if Caption <> S then Caption := S;
  if Label1.Caption <> S then Label1.Caption := S;
end;

end.
